package org.ananas.hc;

import java.util.Locale;
import java.text.MessageFormat;
import java.util.ResourceBundle;
import java.util.MissingResourceException;

public class MessageStore
{
   protected ResourceBundle resource = null;

   protected MessageStore(ResourceBundle resource)
   {
      if(resource == null)
         throw new IllegalArgumentException("ResourceBundle is null");
      else
         this.resource = resource;
   }

   public static MessageStore getMessageStore(String name)
      throws MissingResourceException
   {
      return new MessageStore(ResourceBundle.getBundle(name));
   }

   public static MessageStore getMessageStore(String name,Locale locale)
   {
      return new MessageStore(ResourceBundle.getBundle(name,locale));
   }

   public String getMessage(String key)
   {
      return resource.getString(key);
   }

   public String getMessage(String key,Object[] arguments)
   {
      return MessageFormat.format(resource.getString(key),arguments);
   }

   public String getMessage(String key,Object argument)
   {
      return MessageFormat.format(resource.getString(key),new Object[] { argument });
   }
}
