/**
 * The one class I have found missing the JDK since the very early days.
 * I throw this exception when I have not implemented something yet.
 * I find this cleaner than returning null or throwing a exception
 * that is not clear. When caught, I know immediately what is wrong.
 *
 * @author Beno&#238;t Marchal, http://www.marchal.com/
 */

// Copyright 2001, Benot Marchal.

package org.ananas.hc;

public class NotImplementedException
   extends RuntimeException
{
   /**
    * Creates a NotImplementedException.
    */
   public NotImplementedException()
   {
      super();
   }

   /**
    * Creates a NotImplementedException.
    * @param msg error message
    */
   public NotImplementedException(String msg)
   {
      super(msg);
   }
}
