package org.ananas.hc.compiler;

import org.xml.sax.helpers.NamespaceSupport;

public class HandlerInfo
{
   protected String name;
   protected NamespaceSupport namespaceSupport;
   protected MethodInfo[] methods;
   protected int lastDot;

   public HandlerInfo(String name,
                      NamespaceSupport namespaceSupport,
                      MethodInfo[] methods)
   {
      this.name = name;
      this.namespaceSupport = namespaceSupport;
      this.methods = methods;
      lastDot = this.name.lastIndexOf('.');
   }

   public String getName()
   {
      return name;
   }

   public String getPackageName()
   {
      return lastDot != -1 ? name.substring(0,lastDot) : null;
   }

   public String getClassName()
   {
      return lastDot != -1 ? name.substring(lastDot + 1) : name;
   }

   public NamespaceSupport getNamespaceSupport()
   {
      return namespaceSupport;
   }

   public MethodInfo[] getMethods()
   {
      return methods;
   }

   public int getMethodsCount()
   {
      return methods.length;
   }

   public MethodInfo getMethod(int i)
   {
      return methods[i];
   }
}
