package org.ananas.hc.compiler;

public class MethodInfo
{
   protected String name;
   protected String[] xpaths;
   protected String[][] parameters;

   public MethodInfo(String name,
                     String[] xpaths,
                     String[][] parameters)
   {
      this.name = name;
      this.xpaths = xpaths;
      this.parameters = parameters;
   }

   public String getName()
   {
      return name;
   }

   public String[] getXPaths()
   {
      return xpaths;
   }

   public int getXPathCount()
   {
      return xpaths.length;
   }

   public String getXPath(int i)
   {
      return xpaths[i];
   }

   public String[][] getParameters()
   {
      return parameters;
   }

   public int getParametersCount()
   {
      return parameters.length;
   }

   public String getParameterType(int i)
   {
      return parameters[i][0];
   }

   public String getParameterName(int i)
   {
      return parameters[i][1];
   }

   public String toString()
   {
      StringBuffer buffer = new StringBuffer();
      for(int i = 0;i < xpaths.length;i++)
      {
         buffer.append("@xpath ");
         buffer.append(xpaths[i]);
         buffer.append('\n');
      }
      buffer.append(name);
      buffer.append('(');
      for(int i = 0;i < parameters.length;i++)
      {
         if(i != 0)
            buffer.append(',');
         buffer.append(parameters[i][1]);
         buffer.append(' ');
         buffer.append(parameters[i][0]);
      }
      buffer.append(')');
      return buffer.toString();
   }
}
